#pragma once

// Компилятор nvcc из CUDA Toolkit при компиляции файла включает неявную зависимость
// $CUDA_ROOT/include/cuda_runtime.h, которая в свою очередь включает другие файлы
// из $CUDA_ROOT, а так же из стандартной библиотеки C++. Файлы из внешних ресурсов
// не доступны на этапе конфигурирования сборки, и зависимости из них не учитываются.
// Это, в частности, приводит к поломке сборки с использованием nvcc в режиме sandboxing-а.

// Здесь перечислены такие зависимости. Этот файл добавляется в качестве дополнительной
// зависимости к каждой компиляции nvcc.

#include <cmath>
#include <functional>
#include <new>
#include <utility>
#include <thread>
